package com.iamberry.wechat.handles.agent;

import java.text.MessageFormat;
import java.util.*;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpSession;
import javax.validation.constraints.Max;

import com.iamberry.wechat.core.entity.activity.ActivityDate;
import com.iamberry.wechat.core.entity.coupon.CouponItemDto;
import com.iamberry.wechat.face.coupon.CouponItemService;
import com.iamberry.wechat.face.mq.MQSerivce;
import com.iamberry.wechat.face.order.CodeService;
import com.iamberry.wechat.handles.thanksgiving.ThanksGivingHandler;
import com.iamberry.wechat.service.ActivityUtil;
import com.iamberry.wechat.service.ImberryConfig;
import com.iamberry.wechat.tools.payUtil.RandomUtil;
import org.apache.poi.ss.formula.functions.T;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;

import com.iamberry.wechat.core.entity.ResultMsg;
import com.iamberry.wechat.core.entity.WechatUtils;
import com.iamberry.wechat.core.entity.agent.AgentMemberDto;
import com.iamberry.wechat.core.entity.agent.AgentOrderDto;
import com.iamberry.wechat.core.entity.cart.ShopSalesOrderDto;
import com.iamberry.wechat.core.entity.member.Member;
import com.iamberry.wechat.core.entity.mq.MQMessage;
import com.iamberry.wechat.face.agent.AgentMemberService;
import com.iamberry.wechat.face.agent.AgentOrderService;
import com.iamberry.wechat.face.cart.CartService;
import com.iamberry.wechat.face.member.MemberService;
import com.iamberry.wechat.handles.mq.MQServiceProxy;
import com.iamberry.wechat.tools.NameUtils;
import com.iamberry.wechat.tools.ResultInfo;

/**
 * 微代理 handler 类
 * @author 穆再兴
 *	2016年4月19日
 */
@Deprecated
@Controller
@RequestMapping("/wechat/agent")
public class AgentHandler {

	@Autowired
	private AgentOrderService agentOrderService;	//微代理订单service
	@Autowired
	private MemberService memberService;			//会员service
	/**
	 * 获取当前用户<微代理> 的订单记录
	 * 2016年4月19日
	 * @author 穆再兴
	 * @return json格式
	 */
	@RequestMapping("/agentOrder")
	@ResponseBody
	public ResultMsg getAgentOrderJson(HttpServletRequest req,
			@RequestParam(value="rebackStatus",defaultValue= "4", required=false)Integer rebackStatus,
			@RequestParam(value="pageSize",defaultValue= "6", required=false)String pageSize,
			@RequestParam(value="pageNO",defaultValue= "1", required=false)String pageNO){
		ResultMsg rm = new ResultMsg();
		Member member = WechatUtils.getUserBySession(req);
		member = memberService.getMemberByUserOpenId(member.getUserOpenid());
		
		//查当前用户<微代理>userid 所有订单
		AgentOrderDto orderDto = new AgentOrderDto();
		orderDto.setOrderOpenid(member.getUserOpenid());
		orderDto.getPage().setPageSize(Integer.parseInt(pageSize));
		orderDto.getPage().setPageNumber(Integer.parseInt(pageNO));
		orderDto.setRebackStatus(rebackStatus);
		
		orderDto.getPage().initRecordBegin();
		
		Map<String, Object> map = agentOrderService.getOrderListAndCountByOpenid(orderDto);
		map.put("userIncome", member.getUserIncome() == null ? 0 : member.getUserIncome().intValue());
		rm.setResultCode(ResultInfo.SUCCESSCODE);
		rm.setMessage(NameUtils.getConfig("SUCCESSINFO"));
		rm.setStatus(true);
		rm.setData(map);
		return rm;
	}
	



}
